Bug 240943 - strace hangs when -f option is specified
strace hangs when -f option is specified
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
rawhide
ia64 Linux
high Severity high
: ---
: ---
Assigned To: Jan Kratochvil
Brian Brock
: Regression
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-05-23 05:06 EDT by Jan Kratochvil
Modified: 2007-11-30 17:12 EST (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-05-23 09:45:56 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Jan Kratochvil 2007-05-23 05:06:57 EDT
+++ This bug was initially created as a clone of Bug #237749 +++

`strace -f' hangs on forked processes:
rt_sigprocmask(SIG_BLOCK, [INT CHLD], [], 8) = 0
clone2(Process 5514 attached
child_stack=0, stack_size=0, flags=CLONE_CHILD_CLEARTID|CLONE_CHILD_SETTID|SIGCH
LD, child_tidptr=0x2000000000318090) = 5514
[pid  5513] rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0
[pid  5513] rt_sigprocmask(SIG_BLOCK, [CHLD], [], 8) = 0
[pid  5513] rt_sigprocmask(SIG_SETMASK, [], NULL, 8) = 0
[pid  5513] rt_sigprocmask(SIG_BLOCK, [CHLD], [], 8) = 0
[pid  5513] rt_sigaction(SIGINT, {0x400000000015c560, [], 0}, {SIG_DFL}, 8) = 0
[pid  5513] wait4(-1, Process 5513 suspended

-- Additional comment from jan.kratochvil@redhat.com on 2007-05-17 11:12 EST --
[snip]

This Bug is ia64 specific and the utrace.ia64 author is listed as:
Anil S Keshavamurthy <anil.s.keshavamurthy@intel.com>


-- Additional comment from jan.kratochvil@redhat.com on 2007-05-22 12:22 EST --
Created an attachment (id=155175)
Testcase workarounding the CLONE_PTRACE kernel bug.

Problem is that strace patches the FLAGS parameter of __clone2 () by:
  flags |= CLONE_PTRACE;

but this parameter change gets ignored by the kernel.  The testcase submits
there the CLONE_PTRACE on its own and so works:
  strace -f ./clone

The parameter is found from BSP+CFM by PTRACE_PEEKUSER and retrieved/patched by
PTRACE_PEEKDATA/PTRACE_POKEDATA.

The Bug is present on:
  kernel-2.6.18-8.el5.ia64
  kernel-2.6.18-20.el5.ia64

I did not much see why the parameters got copied at the PTRACE_SYSCALL hit
time.
Comment 2 Jan Kratochvil 2007-05-23 09:45:56 EDT
Bug to be created again.

Note You need to log in before you can comment on or make changes to this bug.